"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isUserTypeJWT = exports.isBasicUserType = exports.isUserType = exports.ValidationError = exports.ErrorWithStatus = exports.isErrorResponse = exports.isSuccessResponse = void 0;
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
const basicValidation_1 = require("./basicValidation");
function isSuccessResponse(response) {
    return response.status < 400;
}
exports.isSuccessResponse = isSuccessResponse;
function isErrorResponse(response) {
    return response.status >= 400;
}
exports.isErrorResponse = isErrorResponse;
class ErrorWithStatus extends Error {
    constructor(message, status) {
        super(message);
        this.status = status;
        this.name = 'ErrorWithStatus';
    }
}
exports.ErrorWithStatus = ErrorWithStatus;
class ValidationError extends ErrorWithStatus {
    constructor(message, errors, status) {
        super(message, status);
        this.name = 'ValidationError';
        this.errors = errors;
    }
}
exports.ValidationError = ValidationError;
function isUserType(obj, securityScheme, type = 'all') {
    switch (type) {
        case 'request':
            if (securityScheme === 'JWT')
                return (0, basicValidation_1.validateUserTypeJWTRequest)(obj);
            else
                return (0, basicValidation_1.validateBasicUserTypeRequest)(obj);
        case 'response':
            if (securityScheme === 'JWT')
                return (0, basicValidation_1.validateUserTypeJWTResponse)(obj);
            else
                return (0, basicValidation_1.validateBasicUserTypeResponse)(obj);
        default:
            if (securityScheme === 'JWT')
                return (0, basicValidation_1.validateUserTypeJWT)(obj);
            else
                return (0, basicValidation_1.validateBasicUserType)(obj);
    }
}
exports.isUserType = isUserType;
function isBasicUserType(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateBasicUserTypeRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateBasicUserTypeResponse)(obj);
        default:
            return (0, basicValidation_1.validateBasicUserType)(obj);
    }
}
exports.isBasicUserType = isBasicUserType;
function isUserTypeJWT(obj, type = 'all') {
    switch (type) {
        case 'request':
            return (0, basicValidation_1.validateUserTypeJWTRequest)(obj);
        case 'response':
            return (0, basicValidation_1.validateUserTypeJWTResponse)(obj);
        default:
            return (0, basicValidation_1.validateUserTypeJWT)(obj);
    }
}
exports.isUserTypeJWT = isUserTypeJWT;
//# sourceMappingURL=types.js.map